"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseArgs = void 0;
const yargs_1 = __importDefault(require("yargs"));
const package_json_1 = __importDefault(require("../package.json"));
const parseArgs = () => {
    const argv = (0, yargs_1.default)(process.argv.slice(2))
        .scriptName(package_json_1.default.name)
        .usage('For more details please visit ' + package_json_1.default.homepage)
        .command('new', `Creates a new workspace and an initial Kix application.`)
        .command('start', 'Builds and run your app, rebuilding on file changes.')
        .options({
        outDir: {
            describe: 'Specify an output folder for all emitted files.',
            type: "string",
        },
        port: {
            describe: 'choose your port',
            type: "number",
        }
    })
        .help('help').argv;
    if (argv instanceof Promise) {
        return argv;
    }
    else {
        return new Promise((resolve) => resolve(argv));
    }
};
exports.parseArgs = parseArgs;
