"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runCommands = void 0;
const child_process_1 = require("child_process");
const templates_1 = require("../templates");
const app_1 = require("../app");
const log_1 = require("../utils/log");
const yargsToWebpackEnv_1 = require("./utils/yargsToWebpackEnv");
const selfIfCanUpdate_1 = require("./utils/selfIfCanUpdate");
const runCommands = (argv) => __awaiter(void 0, void 0, void 0, function* () {
    switch (argv._[0]) {
        case "new":
            if (yield (0, selfIfCanUpdate_1.selfIfCanUpdate)(argv)) {
                const argvAppName = argv._[1];
                (0, templates_1.createTemplate)(argvAppName ? String(argvAppName) : undefined);
            }
            break;
        default:
            (0, child_process_1.spawn)(`npm exec --call "${(0, yargsToWebpackEnv_1.yargsToWebpackEnv)("npm run", argv)}"`, {
                shell: true,
                cwd: app_1.runDirectory,
                stdio: "inherit",
            }).on("error", log_1.log.error);
    }
});
exports.runCommands = runCommands;
