"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.selfIfCanUpdate = void 0;
const log_1 = require("../../utils/log");
const startLoader_1 = require("../../utils/startLoader");
const pacote_1 = __importDefault(require("pacote"));
const child_process_1 = require("child_process");
const app_1 = require("../../app");
const package_json_1 = __importDefault(require("../../package.json"));
const runKeywordForPackage = "APP_RUN_KEY_OOOOO_ORD_FOR_PACKAGER";
const selfIfCanUpdate = (argv) => __awaiter(void 0, void 0, void 0, function* () {
    const packageSelfName = package_json_1.default.name;
    const stopLoader = (0, startLoader_1.startLoader)("Please wait...");
    const manifest = yield pacote_1.default.manifest(packageSelfName).finally(stopLoader).catch(log_1.log.warn);
    const isUpdated = (package_json_1.default === null || package_json_1.default === void 0 ? void 0 : package_json_1.default.version) === (manifest === null || manifest === void 0 ? void 0 : manifest.version) || argv[runKeywordForPackage] === runKeywordForPackage;
    if (!isUpdated) {
        yield new Promise((resolve) => {
            (0, child_process_1.spawn)(`npm update -g ${packageSelfName}`, [], {
                shell: true,
                stdio: 'inherit'
            })
                .on("error", log_1.log.error)
                .on("close", resolve);
        });
        (0, child_process_1.spawn)(packageSelfName, [...process.argv.slice(2), `--${runKeywordForPackage}="${runKeywordForPackage}"`], {
            shell: true,
            cwd: app_1.runDirectory,
            stdio: 'inherit'
        });
    }
    return isUpdated;
});
exports.selfIfCanUpdate = selfIfCanUpdate;
