"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPromptsQuestions = exports.ModuleBuilder = exports.TemplateTypes = void 0;
const prompts_1 = __importDefault(require("prompts"));
const colby_1 = require("colby");
var TemplateTypes;
(function (TemplateTypes) {
    TemplateTypes[TemplateTypes["JS"] = 0] = "JS";
    TemplateTypes[TemplateTypes["TS"] = 1] = "TS";
})(TemplateTypes || (exports.TemplateTypes = TemplateTypes = {}));
var ModuleBuilder;
(function (ModuleBuilder) {
    ModuleBuilder[ModuleBuilder["WEBPACK"] = 0] = "WEBPACK";
    ModuleBuilder[ModuleBuilder["VITE"] = 1] = "VITE";
})(ModuleBuilder || (exports.ModuleBuilder = ModuleBuilder = {}));
const getPromptsQuestions = (argvAppName) => __awaiter(void 0, void 0, void 0, function* () {
    const validateProjectName = (value) => (!!((value = (value + "").trim()) && /^[a-zA-Z0-9_.-]*$/gm.test(value)));
    const appName = (argvAppName && validateProjectName(argvAppName)) ? argvAppName.trim() : yield (0, prompts_1.default)([{
            type: 'text',
            name: 'value',
            message: 'Please specify the project name:',
            validate: (value) => validateProjectName(value)
        }]).then(({ value }) => value.trim());
    const templateType = yield (0, prompts_1.default)([{
            type: 'select',
            name: 'value',
            message: 'Choose a template',
            choices: [
                { title: (0, colby_1.toRgb)(255, 255, 0)('Javascript Template '), value: TemplateTypes.JS },
                { title: (0, colby_1.toRgb)(0, 122, 204)('Typescript Template '), value: TemplateTypes.TS }
            ]
        }]).then(({ value }) => value);
    const moduleBuilder = yield (0, prompts_1.default)([{
            type: 'select',
            name: 'value',
            message: 'Select the module builder',
            choices: [
                { title: (0, colby_1.toRgb)(28, 120, 192)("WEBPACK"), value: ModuleBuilder.WEBPACK, description: "Recommended" },
                { title: (0, colby_1.toRgb)(255, 228, 96)("VITE"), value: ModuleBuilder.VITE }
            ]
        }]).then(({ value }) => value);
    return {
        appName,
        templateType,
        moduleBuilder
    };
});
exports.getPromptsQuestions = getPromptsQuestions;
