"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.bindingPattern = void 0;
const typescript_1 = __importDefault(require("typescript"));
const identifier_1 = require("./identifier");
const factory = typescript_1.default.factory;
const bindingPattern = (pattern) => {
    return factory[pattern.type](pattern.elements.reduce((bindElements, item) => {
        const propertyName = item[1] && item[0];
        const name = item[1] ? (0, exports.bindingPattern)(item[1]) : (0, identifier_1.identifier)(item[0]);
        bindElements.push(factory.createBindingElement(undefined, propertyName, name, item[2]));
        return bindElements;
    }, []));
};
exports.bindingPattern = bindingPattern;
