"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.nodeToken = void 0;
const typescript_1 = __importDefault(require("typescript"));
const identifier_1 = require("./identifier");
const stringLiteral_1 = require("./stringLiteral");
const factory = typescript_1.default.factory;
function nodeToken(nodes, token = typescript_1.default.SyntaxKind.EqualsToken) {
    return nodes.reduce((property1, property2) => {
        return factory.createBinaryExpression((0, identifier_1.identifier)(property1), factory.createToken(token), (0, stringLiteral_1.stringLiteral)(property2));
    });
}
exports.nodeToken = nodeToken;
