"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.propertyAccessExpression = void 0;
const typescript_1 = __importDefault(require("typescript"));
const identifier_1 = require("./identifier");
const stringLiteral_1 = require("./stringLiteral");
const factory = typescript_1.default.factory;
function propertyAccessExpression(properties, accessType = "createElementAccessExpression") {
    let initValueFunction = accessType === "createElementAccessExpression" ? stringLiteral_1.stringLiteral : identifier_1.identifier;
    return properties.reduce((property1, property2) => {
        return factory[accessType]((0, identifier_1.identifier)(property1), initValueFunction(property2));
    });
}
exports.propertyAccessExpression = propertyAccessExpression;
