"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrowFunction = void 0;
const typescript_1 = __importDefault(require("typescript"));
const createGlobalBlockNodesVisitor_1 = require("./utils/createGlobalBlockNodesVisitor");
exports.ArrowFunction = (0, createGlobalBlockNodesVisitor_1.createGlobalBlockNodesVisitor)((visitedNode, declarationVariableNode, context) => {
    return context.factory.updateArrowFunction(visitedNode, typescript_1.default.getModifiers(visitedNode), visitedNode.typeParameters, visitedNode.parameters, visitedNode.type, visitedNode.equalsGreaterThanToken, ConciseBodyToMultiLineBlock(visitedNode.body, context, [
        declarationVariableNode,
    ]));
});
const ConciseBodyToMultiLineBlock = (body, context, addStatement = []) => {
    if (typescript_1.default.isBlock(body)) {
        return context.factory.updateBlock(body, [...addStatement, ...body.statements]);
    }
    return context.factory.createBlock([
        ...addStatement,
        context.factory.createReturnStatement(body)
    ], true);
};
