"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CallExpression = void 0;
const typescript_1 = __importDefault(require("typescript"));
const callChainFunction_1 = require("../factoryCode/callChainFunction");
const CallExpression = (node, visitor, context) => {
    const oldValue = context.JsxHaveQuestionDotToken;
    let newNode = typescript_1.default.visitEachChild(node, visitor, context);
    if (context.JsxHaveQuestionDotToken === node) {
        newNode = (0, callChainFunction_1.callChainFunction)(newNode.expression, [...newNode.arguments]);
    }
    context.JsxHaveQuestionDotToken = oldValue;
    return newNode;
};
exports.CallExpression = CallExpression;
