"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Identifier = void 0;
const typescript_1 = __importDefault(require("typescript"));
const callFunction_1 = require("../factoryCode/callFunction");
const stringLiteral_1 = require("../factoryCode/stringLiteral");
const Identifier = (node, visitor, context) => {
    if (context.getJSXPropRegistrationIdentifier && context.isSubstitutionEnabled(node)) {
        const JSXPropRegistrationIdentifier = context.getJSXPropRegistrationIdentifier();
        const identifierName = typescript_1.default.idText(node);
        context.addIdentifiersChannelCallback(identifierName, (identifierState) => {
            identifierState.isJsx = true;
            identifierState.substituteCallback = (indexIdToUniqueString, declarationIdentifier) => {
                context.substituteNodesList.set(node, () => {
                    return (0, callFunction_1.callFunction)(JSXPropRegistrationIdentifier, [
                        declarationIdentifier,
                        (0, stringLiteral_1.stringLiteral)(indexIdToUniqueString)
                    ]);
                });
            };
            return node;
        });
    }
    return node;
};
exports.Identifier = Identifier;
