"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IfStatement = void 0;
const typescript_1 = __importDefault(require("typescript"));
const createObject_1 = require("../factoryCode/createObject");
const variableStatement_1 = require("../factoryCode/variableStatement");
const createBlockVisitor_1 = require("./utils/createBlockVisitor");
const visitIfStatementBlockNode = (0, createBlockVisitor_1.createBlockVisitor)((node, visitor, context) => {
    return visitor(node);
}, false);
const IfStatement = (node, visitor, context) => {
    const expression = visitor(node.expression);
    const visitedThenStatement = visitIfStatementBlockNode(node.thenStatement, visitor, context);
    const visitedElseStatement = node.elseStatement && visitIfStatementBlockNode(node.elseStatement, visitor, context);
    return context.factory.updateIfStatement(node, expression, statementToBlock(visitedThenStatement[0], visitedThenStatement[1], context), visitedElseStatement && statementToBlock(visitedElseStatement[0], visitedElseStatement[1], context));
};
exports.IfStatement = IfStatement;
const statementToBlock = (visitedNode, variableState, context) => {
    if (!visitedNode || !variableState.blockScopeIdentifiers)
        return visitedNode;
    const declarationNode = (0, variableStatement_1.variableStatement)([
        [variableState.blockScopeIdentifiers, (0, createObject_1.createObject)([])]
    ]);
    if (typescript_1.default.isBlock(visitedNode)) {
        return context.factory.updateBlock(visitedNode, [declarationNode, ...visitedNode.statements]);
    }
    else {
        return context.factory.createBlock([
            declarationNode,
            visitedNode
        ], true);
    }
};
