"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostfixUnaryExpression = exports.ValueChangeNodeTokens = void 0;
const typescript_1 = __importDefault(require("typescript"));
const nodeToken_1 = require("../factoryCode/nodeToken");
const propertyAccessExpression_1 = require("../factoryCode/propertyAccessExpression");
exports.ValueChangeNodeTokens = [
    typescript_1.default.SyntaxKind.PlusPlusToken,
    typescript_1.default.SyntaxKind.MinusMinusToken
];
const PostfixUnaryExpression = (node, visitor, context) => {
    const visitedNode = typescript_1.default.visitEachChild(node, visitor, context);
    if (typescript_1.default.isIdentifier(visitedNode.operand) && exports.ValueChangeNodeTokens.includes(node.operator)) {
        const identifierName = typescript_1.default.idText(visitedNode.operand);
        context.addIdentifiersChannelCallback(identifierName, (identifierState) => {
            identifierState.isChanged = true;
            identifierState.substituteCallback = (indexIdToUniqueString, declarationIdentifier) => {
                context.substituteNodesList.set(visitedNode, () => {
                    return (0, nodeToken_1.nodeToken)([
                        context.factory.createParenthesizedExpression((0, nodeToken_1.nodeToken)([
                            (0, propertyAccessExpression_1.propertyAccessExpression)([
                                declarationIdentifier,
                                indexIdToUniqueString
                            ], "createPropertyAccessExpression"),
                            context.factory.createPrefixUnaryExpression(visitedNode.operator, visitedNode.operand)
                        ], typescript_1.default.SyntaxKind.EqualsToken)),
                        context.factory.createNumericLiteral("1")
                    ], typescript_1.default.SyntaxKind.MinusToken);
                });
            };
        });
    }
    return visitedNode;
};
exports.PostfixUnaryExpression = PostfixUnaryExpression;
