"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrefixUnaryExpression = void 0;
const typescript_1 = __importDefault(require("typescript"));
const nodeToken_1 = require("../factoryCode/nodeToken");
const propertyAccessExpression_1 = require("../factoryCode/propertyAccessExpression");
const PostfixUnaryExpression_1 = require("./PostfixUnaryExpression");
const PrefixUnaryExpression = (node, visitor, context) => {
    const visitedNode = typescript_1.default.visitEachChild(node, visitor, context);
    if (typescript_1.default.isIdentifier(visitedNode.operand) && PostfixUnaryExpression_1.ValueChangeNodeTokens.includes(node.operator)) {
        const identifierName = typescript_1.default.idText(visitedNode.operand);
        context.addIdentifiersChannelCallback(identifierName, (identifierState) => {
            identifierState.isChanged = true;
            identifierState.substituteCallback = (indexIdToUniqueString, declarationIdentifier) => {
                context.substituteNodesList.set(visitedNode, () => {
                    return (0, nodeToken_1.nodeToken)([
                        (0, propertyAccessExpression_1.propertyAccessExpression)([
                            declarationIdentifier,
                            indexIdToUniqueString
                        ], "createPropertyAccessExpression"),
                        context.factory.updatePrefixUnaryExpression(visitedNode, visitedNode.operand)
                    ], typescript_1.default.SyntaxKind.EqualsToken);
                });
            };
        });
    }
    return visitedNode;
};
exports.PrefixUnaryExpression = PrefixUnaryExpression;
