"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SourceFile = void 0;
const typescript_1 = __importDefault(require("typescript"));
const moduleSourceFileBodyVisitor_1 = require("./utils/moduleSourceFileBodyVisitor");
const SourceFile = (node, visitor, context) => {
    if (typescript_1.default.ScriptTarget.JSON === node.languageVersion)
        return node;
    const substituteNodesList = context.substituteNodesList = new Map();
    context.addDeclaredIdentifierState = () => { };
    context.addIdentifiersChannelCallback = () => { };
    node = (0, moduleSourceFileBodyVisitor_1.moduleSourceFileBodyVisitor)(node, visitor, context);
    if (substituteNodesList.size) {
        const replaceNodesVisitor = (node) => {
            var _a;
            return (_a = (substituteNodesList.get(node) || typescript_1.default.visitEachChild)) === null || _a === void 0 ? void 0 : _a(node, replaceNodesVisitor, context);
        };
        node = typescript_1.default.visitEachChild(node, replaceNodesVisitor, context);
        substituteNodesList.clear();
    }
    return node;
};
exports.SourceFile = SourceFile;
