"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VariableStatement = void 0;
const typescript_1 = __importDefault(require("typescript"));
const identifier_1 = require("../factoryCode/identifier");
const nodeToken_1 = require("../factoryCode/nodeToken");
const propertyAccessExpression_1 = require("../factoryCode/propertyAccessExpression");
const getVariableDeclarationNames_1 = require("../utils/getVariableDeclarationNames");
const VariableStatement = (node, visitor, context) => {
    const visitedVariableStatement = typescript_1.default.visitEachChild(node, visitor, context);
    const returnValue = [];
    for (const variableDeclaration of visitedVariableStatement.declarationList.declarations) {
        const declarationNamesObject = (0, getVariableDeclarationNames_1.getVariableDeclarationNames)(variableDeclaration);
        const declarationNode = context.factory.updateVariableStatement(visitedVariableStatement, typescript_1.default.getModifiers(visitedVariableStatement), context.factory.updateVariableDeclarationList(visitedVariableStatement.declarationList, [variableDeclaration]));
        returnValue.push(declarationNode);
        for (const declarationIdentifierName in declarationNamesObject) {
            context.addDeclaredIdentifierState(declarationIdentifierName);
            context.addIdentifiersChannelCallback(declarationIdentifierName, (identifierState) => {
                identifierState.declaredFlag = visitedVariableStatement.declarationList.flags;
                identifierState.substituteCallback = (indexIdToUniqueString, declarationIdentifier) => {
                    context.substituteNodesList.set(declarationNode, (_, substituteVisitor) => {
                        context.substituteNodesList.delete(declarationNode);
                        return [
                            substituteVisitor(declarationNode),
                            context.factory.createExpressionStatement((0, nodeToken_1.nodeToken)([
                                (0, propertyAccessExpression_1.propertyAccessExpression)([
                                    declarationIdentifier,
                                    indexIdToUniqueString
                                ], "createPropertyAccessExpression"),
                                (0, identifier_1.identifier)(declarationIdentifierName)
                            ]))
                        ];
                    });
                };
            });
        }
    }
    return returnValue;
};
exports.VariableStatement = VariableStatement;
