"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PropertyAccessExpressionOrElementAccessExpression = void 0;
const typescript_1 = __importDefault(require("typescript"));
const callFunction_1 = require("../../factoryCode/callFunction");
const getExpressionNames_1 = require("./getExpressionNames");
const PropertyAccessExpressionOrElementAccessExpression = (node, visitor, context) => {
    if (context.getJSXPropRegistrationIdentifier) {
        const expressionIdentifiers = [];
        const haveQuestionDotToken = (0, getExpressionNames_1.getExpressionNames)(node, expressionIdentifiers);
        if (haveQuestionDotToken && node.parent) {
            context.JsxHaveQuestionDotToken = node.parent;
        }
        return visitor((0, callFunction_1.callFunction)(context.getJSXPropRegistrationIdentifier(), expressionIdentifiers));
    }
    return typescript_1.default.visitEachChild(node, visitor, context);
};
exports.PropertyAccessExpressionOrElementAccessExpression = PropertyAccessExpressionOrElementAccessExpression;
