"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getExpressionNames = void 0;
const typescript_1 = __importDefault(require("typescript"));
const stringLiteral_1 = require("../../factoryCode/stringLiteral");
const getExpressionNames = (node, expressionIdentifiers = [], haveQuestionDotToken = false) => {
    if (typescript_1.default.isPropertyAccessExpression(node)) {
        if (node.questionDotToken) {
            haveQuestionDotToken = true;
        }
        haveQuestionDotToken = (0, exports.getExpressionNames)(node.expression, expressionIdentifiers, haveQuestionDotToken) || haveQuestionDotToken;
        if (typescript_1.default.isIdentifier(node.name)) {
            expressionIdentifiers.push((0, stringLiteral_1.stringLiteral)(typescript_1.default.idText(node.name)));
        }
    }
    else if (typescript_1.default.isElementAccessExpression(node)) {
        if (node.questionDotToken) {
            haveQuestionDotToken = true;
        }
        haveQuestionDotToken = (0, exports.getExpressionNames)(node.expression, expressionIdentifiers, haveQuestionDotToken) || haveQuestionDotToken;
        expressionIdentifiers.push(node.argumentExpression);
    }
    else {
        expressionIdentifiers.push(node);
    }
    return haveQuestionDotToken;
};
exports.getExpressionNames = getExpressionNames;
