"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.moduleSourceFileBodyVisitor = void 0;
const typescript_1 = __importDefault(require("typescript"));
const createObject_1 = require("../../factoryCode/createObject");
const variableStatement_1 = require("../../factoryCode/variableStatement");
const createBlockVisitor_1 = require("./createBlockVisitor");
const moduleBodyNodesVisitor = (0, createBlockVisitor_1.createBlockVisitor)((sourceFileNode, visitor, context) => {
    return typescript_1.default.visitEachChild(sourceFileNode, visitor, context);
}, true);
const moduleSourceFileBodyVisitor = (sourceFileNode, visitor, context) => {
    let [visitedStatements, variableState] = moduleBodyNodesVisitor(sourceFileNode, visitor, context);
    if (variableState.globalScopeIdentifiers) {
        const declarationNode = (0, variableStatement_1.variableStatement)([
            [variableState.globalScopeIdentifiers, (0, createObject_1.createObject)([])]
        ]);
        return context.factory.updateSourceFile(sourceFileNode, [
            declarationNode,
            ...visitedStatements.statements
        ], sourceFileNode.isDeclarationFile, sourceFileNode.referencedFiles, sourceFileNode.typeReferenceDirectives, sourceFileNode.hasNoDefaultLib, sourceFileNode.libReferenceDirectives);
    }
    return visitedStatements;
};
exports.moduleSourceFileBodyVisitor = moduleSourceFileBodyVisitor;
