"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeInitializer = void 0;
const typescript_1 = __importDefault(require("typescript"));
const safeInitializer = (initializer) => {
    if (!initializer)
        return;
    if (initializer.kind === typescript_1.default.SyntaxKind.JsxExpression) {
        if (!initializer.expression) {
            return;
        }
        return initializer.expression;
    }
    return initializer;
};
exports.safeInitializer = safeInitializer;
