"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useJsxPropRegistration = void 0;
const arrowFunction_1 = require("../../factoryCode/arrowFunction");
const useJsxPropRegistration = (node, visitor, context, callBeforeReturn) => {
    const OldGetRegistrationIdentifier = context.getJSXPropRegistrationIdentifier;
    let getRegistrationIdentifier;
    context.getJSXPropRegistrationIdentifier = () => (getRegistrationIdentifier || (getRegistrationIdentifier = context.factory.createUniqueName("_R")));
    const newNode = visitor(node);
    context.getJSXPropRegistrationIdentifier = OldGetRegistrationIdentifier;
    if (getRegistrationIdentifier) {
        return callBeforeReturn((0, arrowFunction_1.arrowFunction)([getRegistrationIdentifier], [], newNode), true);
    }
    return callBeforeReturn(newNode, false);
};
exports.useJsxPropRegistration = useJsxPropRegistration;
