"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getVariableDeclarationNames = void 0;
const typescript_1 = __importDefault(require("typescript"));
const getVariableDeclarationNames = (node, currentThree = [], three = {}) => {
    const currentThreeList = [...currentThree];
    const identifierName = (node.propertyName || node.name);
    if (typescript_1.default.isIdentifier(identifierName)) {
        currentThreeList.push(typescript_1.default.idText(identifierName));
        if (typescript_1.default.isIdentifier(node.name)) {
            three[typescript_1.default.idText(node.name)] = currentThreeList;
        }
    }
    if (node && typescript_1.default.isObjectBindingPattern(node.name)) {
        for (const element of node.name.elements) {
            (0, exports.getVariableDeclarationNames)(element, [...currentThreeList], three);
        }
    }
    return three;
};
exports.getVariableDeclarationNames = getVariableDeclarationNames;
