"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useObjectListener = exports.useListener = exports.createAttribute = exports.createElement = exports.Router = exports.Component = exports.kix = void 0;
const SETTER_ID_KEY = "_$IDS";
const KIX_UNIQUE_APP_USABLE_KEY = Math.random() + SETTER_ID_KEY;
const NODE_UNMOUNT_FUNCTION_KEY = KIX_UNIQUE_APP_USABLE_KEY + SETTER_ID_KEY;
const NODE_MOUNT_FUNCTION_KEY = NODE_UNMOUNT_FUNCTION_KEY + SETTER_ID_KEY;
const NODE_MOUNT_VALUE_KEY = NODE_MOUNT_FUNCTION_KEY + SETTER_ID_KEY;
const WindowObject = window;
const DocumentObject = WindowObject.document;
const GlobalRouteParams = {};
const RoutePathParams = {};
const type = (arg) => Object.prototype.toString.call(arg);
const isHtml = (tag) => { var _a; return (((_a = tag === null || tag === void 0 ? void 0 : tag.__proto__) === null || _a === void 0 ? void 0 : _a.ELEMENT_NODE) === Node.ELEMENT_NODE); };
const createMarker = () => DocumentObject.createTextNode("");
const abstractNodes = {
    $(objectNode, objectPropertyName, kix, createElement, setAttribute, createObjectElement) {
        const eventsGetFunc = objectNode["E"];
        const dynamicAttributesObject = objectNode["D"];
        const JsxElementObject = Object.assign(Object.assign({}, objectNode[objectPropertyName]), { [KIX_UNIQUE_APP_USABLE_KEY]: (htmlTagNode) => {
                delete JsxElementObject[KIX_UNIQUE_APP_USABLE_KEY];
                if (dynamicAttributesObject) {
                    for (const dynamicAttributeName in dynamicAttributesObject) {
                        const onChangeAttribute = (value) => {
                            if (htmlTagNode) {
                                setAttribute(htmlTagNode, dynamicAttributeName, value);
                            }
                            else {
                                JsxElementObject[dynamicAttributeName] = value;
                            }
                        };
                        onChangeAttribute(propertyRegistration(dynamicAttributesObject[dynamicAttributeName], onChangeAttribute));
                    }
                }
                if (eventsGetFunc) {
                    for (const eventName in eventsGetFunc()) {
                        if (htmlTagNode) {
                            htmlTagNode.addEventListener(eventName, (e) => {
                                const eventCallback = eventsGetFunc()[eventName];
                                if (typeof eventCallback === "function") {
                                    eventCallback(e, htmlTagNode);
                                }
                            });
                        }
                        else {
                            JsxElementObject["on" + eventName.replace(/^\w/, c => c.toUpperCase())] = (event, tagNode) => { var _a, _b; return ((_b = (_a = eventsGetFunc())[eventName]) === null || _b === void 0 ? void 0 : _b.call(_a, event, tagNode)); };
                        }
                    }
                }
            } });
        return JsxElementObject;
    },
    $C(objectNode, objectPropertyName, kix, createElement, setAttribute, createObjectElement) {
        var _a;
        const component = objectNode[objectPropertyName];
        const props = objectNode["a"] || {};
        const dynamicProps = objectNode["d"] || {};
        const componentChildren = objectNode["i"];
        if (!(component instanceof Function))
            return;
        const registerProps = (state) => {
            for (const propsName in props) {
                state[propsName] = props[propsName];
            }
            for (const dynamicPropsName in dynamicProps) {
                state[dynamicPropsName] = propertyRegistration(dynamicProps[dynamicPropsName], (value) => (state[dynamicPropsName] = value));
            }
        };
        if ((_a = component.prototype) === null || _a === void 0 ? void 0 : _a.render) {
            class ComponentNode extends component {
                constructor() {
                    super();
                    registerProps(this, dynamicProps);
                    this.children = componentChildren;
                    this.render = this.render || (() => { });
                }
            }
            return new ComponentNode().render();
        }
        else {
            const propsSate = { children: componentChildren };
            registerProps(propsSate, dynamicProps);
            return component(propsSate);
        }
    },
    $X(objectNode, objectPropertyName, kix, createElement, setAttribute, createObjectElement) {
        const JsxElement = objectNode[objectPropertyName];
        const defaultXmlnsNamespaceURI = objectNode["$D"];
        const xmlnsList = Object.assign({}, objectNode);
        delete xmlnsList["$X"];
        delete xmlnsList["$D"];
        if (defaultXmlnsNamespaceURI) {
            createElement = (elementName) => {
                return DocumentObject.createElementNS(defaultXmlnsNamespaceURI, elementName);
            };
        }
        for (const xmlnsName in xmlnsList) {
            const createElementCache = createElement;
            const setAttributeCache = setAttribute;
            createElement = (elementName) => {
                if (elementName.startsWith(`${xmlnsName}:`)) {
                    return DocumentObject.createElementNS(xmlnsList[xmlnsName], elementName);
                }
                return createElementCache(elementName);
            };
            setAttribute = (node, attributeName, value) => {
                if (attributeName.startsWith(`${xmlnsName}:`)) {
                    node.setAttributeNS(xmlnsList[xmlnsName], attributeName, value);
                }
                else {
                    return setAttributeCache(node, attributeName, value);
                }
            };
        }
        return createApp(createElement, setAttribute)(null, JsxElement);
    },
    $D(objectNode, objectPropertyName, kix, createElement, setAttribute, createObjectElement) {
        const [markers, Render] = createSpaceController();
        return [
            markers,
            () => Render(propertyRegistration(objectNode[objectPropertyName], (renderElement) => Render(renderElement))),
        ];
    },
    "route-link"(objectNode, objectPropertyName, kix, createElement, setAttribute, createObjectElement) {
        const renderJsxObject = Object.assign(Object.assign({ a: objectNode[objectPropertyName] }, objectNode), { [KIX_UNIQUE_APP_USABLE_KEY]: (htmlNode) => {
                var _a;
                (_a = objectNode[KIX_UNIQUE_APP_USABLE_KEY]) === null || _a === void 0 ? void 0 : _a.call(objectNode, htmlNode);
                htmlNode.addEventListener("click", (e) => {
                    e.preventDefault();
                    WindowObject.history.pushState({ routeTime: new Date().getTime() }, DocumentObject.title, htmlNode.getAttribute("href"));
                    WindowObject.dispatchEvent(new CustomEvent('popstate'));
                    const { routeScroll } = objectNode;
                    if (routeScroll === undefined || routeScroll) {
                        WindowObject.scrollTo(0, 0);
                    }
                });
            } });
        delete renderJsxObject[objectPropertyName];
        return renderJsxObject;
    },
    "route-block"(objectNode, objectPropertyName, kix, createElement, setAttribute, createObjectElement) {
        const [markers, Render] = createSpaceController();
        const startMarker = createMarker();
        const endMarker = createMarker();
        const renderComponent = () => {
            let { ifEmptyComponent } = objectNode;
            let markerNode = startMarker;
            while (markerNode && markerNode !== endMarker) {
                const isTextNode = markerNode.nodeType === Node.TEXT_NODE;
                if (!isTextNode || (isTextNode && markerNode.textContent.trim().length)) {
                    ifEmptyComponent = "";
                    break;
                }
                markerNode = markerNode.nextSibling;
            }
            Render(ifEmptyComponent);
        };
        (0, exports.useObjectListener)(objectNode, renderComponent);
        WindowObject.addEventListener(KIX_UNIQUE_APP_USABLE_KEY, renderComponent);
        return [
            markers,
            startMarker,
            objectNode[objectPropertyName],
            endMarker,
            renderComponent,
        ];
    },
    "route-switch"(objectNode, objectPropertyName, kix, createElement, setAttribute, createObjectElement) {
        var _a;
        (_a = objectNode[KIX_UNIQUE_APP_USABLE_KEY]) === null || _a === void 0 ? void 0 : _a.call(objectNode);
        const escapeRegExp = [/[-[\]{}()*+!<=?.\/\\^$|#\s,]/g, "\\$&"];
        const renderComponent = () => {
            const { path, unique, component } = objectNode;
            const queryRegExpList = (unique ? [
                escapeRegExp,
                [/\((.*?)\)/g, "(?:$1)?"],
                [/(\(\?)?:\w+/g, (match, optional) => optional ? match : "([^/]+)"],
                [/\*\w+/g, "(.*?)"]
            ] : [
                escapeRegExp,
                [/:[^\s/]+/g, "([\\w-]+)"]
            ]).reduce((repl, reg) => repl.replace(reg[0], reg[1]), path);
            const queryRegExp = new RegExp(unique ? "^" + queryRegExpList + "$" : queryRegExpList, "i");
            const localPath = decodeURI(DocumentObject.location.pathname);
            const matchPath = localPath.match(queryRegExp) || [];
            const pathParams = exports.Router.getPathParams(path);
            path.replace(/\/:/g, "/").match(queryRegExp).forEach((paramName, index) => {
                GlobalRouteParams[paramName] = pathParams[paramName] = matchPath[index];
            });
            Render(queryRegExp.test(localPath) ? component : "");
        };
        const resetComponentEvent = () => {
            renderComponent();
            WindowObject.dispatchEvent(new CustomEvent(KIX_UNIQUE_APP_USABLE_KEY));
        };
        const [markers, Render] = createSpaceController();
        (0, exports.useObjectListener)(objectNode, resetComponentEvent);
        WindowObject.addEventListener("popstate", resetComponentEvent);
        return [markers, renderComponent];
    },
};
const abstractAttributes = {
    [KIX_UNIQUE_APP_USABLE_KEY](node, attributeName, value, setAttribute) {
        value(node);
    }
};
function createApp(createElementName, setAttribute) {
    const setAttributeTagNode = (node, attributeName, value) => {
        if (abstractAttributes.hasOwnProperty(attributeName)) {
            abstractAttributes[attributeName](node, attributeName, value, setAttribute);
        }
        else if (value instanceof Function) {
            setAttributeTagNode(node, attributeName, value(node));
        }
        else {
            setAttribute(node, attributeName, String(value !== null && value !== void 0 ? value : ""));
        }
    };
    function createObjectElement(parent, objectNode, elementNode) {
        for (const objectPropertyName in objectNode) {
            if (elementNode) {
                setAttributeTagNode(elementNode, objectPropertyName, objectNode[objectPropertyName]);
            }
            else {
                if (objectPropertyName in abstractNodes) {
                    return kix(parent, abstractNodes[objectPropertyName](objectNode, objectPropertyName, kix, createElementName, setAttributeTagNode, createObjectElement));
                }
                kix((elementNode = createElementName(objectPropertyName)), objectNode[objectPropertyName]);
            }
        }
        return (isHtml(parent) && parent.appendChild(elementNode)), elementNode;
    }
    const kix = (parent, children) => {
        switch (type(children)) {
            case "[object Array]":
                return children.map((childNode) => kix(parent, childNode));
            case "[object Function]":
                return kix(parent, children(parent));
            case "[object Object]":
                return createObjectElement(parent, children);
            case "[object Promise]":
                const [markers, Render] = createSpaceController();
                children.then((result) => Render(result));
                return kix(parent, markers);
            case "[object Undefined]":
            case "[object Null]":
            case "[object Boolean]":
                children = "";
            default:
                if (!isHtml(children)) {
                    children = DocumentObject.createTextNode(children + "");
                }
        }
        return (isHtml(parent) && parent.appendChild(children)), children;
    };
    return kix;
}
let INC_REGiSTER_ID = 0;
const removePropsCallback = (id, value, startIndex, args) => {
    var _a, _b;
    for (let index = startIndex + 1; index < args.length; ++index) {
        if (typeof value === "object") {
            const property = args[index];
            const setterObject = (_b = (_a = Object.getOwnPropertyDescriptor(value, property)) === null || _a === void 0 ? void 0 : _a.set) === null || _b === void 0 ? void 0 : _b[SETTER_ID_KEY];
            if (setterObject) {
                delete setterObject[id];
            }
            value = value === null || value === void 0 ? void 0 : value[property];
        }
    }
};
const registerKeyProperty = (args, index, id, object, property, { get, set, configurable }, callback) => {
    let value = object === null || object === void 0 ? void 0 : object[property];
    const setterObject = { [id]: callback };
    if (configurable !== false) {
        get = (get || (() => value));
        const setter = (setValue) => {
            if (set) {
                set(setValue);
            }
            if (value !== setValue) {
                removePropsCallback(id, value, index, args);
            }
            value = setValue;
            for (const keyId in setterObject) {
                setterObject[keyId]();
            }
        };
        setter[SETTER_ID_KEY] = setterObject;
        Object.defineProperty(object, property, {
            enumerable: true,
            configurable: true,
            get: get,
            set: setter
        });
    }
    return value;
};
const propertyRegistration = (register, callback) => {
    const id = INC_REGiSTER_ID++;
    const resetCall = () => callback(getValue());
    const getValue = () => register(function () {
        return Array.prototype.reduce.call(arguments, (prevValue, property, index) => {
            var _a;
            let value = prevValue === null || prevValue === void 0 ? void 0 : prevValue[property];
            if (typeof prevValue === "object") {
                const descriptor = Object.getOwnPropertyDescriptor(prevValue, property);
                const setterObject = (_a = descriptor === null || descriptor === void 0 ? void 0 : descriptor.set) === null || _a === void 0 ? void 0 : _a[SETTER_ID_KEY];
                if (setterObject) {
                    setterObject[id] = resetCall;
                }
                else if (descriptor) {
                    value = registerKeyProperty(arguments, index, id, prevValue, property, descriptor, resetCall);
                }
            }
            return typeof value === "function" ? value.bind(prevValue) : value;
        });
    });
    return getValue();
};
const loopEachItems = (items, callback) => {
    if (items instanceof Array) {
        for (const item of items) {
            loopEachItems(item, callback);
        }
    }
    else {
        callback(items);
    }
};
const createSpaceController = () => {
    const startMarker = createMarker();
    const endMarker = createMarker();
    const storage = new Map();
    let currentNode = startMarker;
    const getNodeCachedSet = (node) => {
        let cachedSet = storage.get(node);
        return cachedSet || ((storage.set(node, (cachedSet = new Set()))), cachedSet);
    };
    const removeUnusedNodes = () => {
        var _a;
        while (currentNode !== endMarker) {
            const nextSibling = currentNode.nextSibling;
            currentNode.remove();
            (_a = currentNode[NODE_UNMOUNT_FUNCTION_KEY]) === null || _a === void 0 ? void 0 : _a.call(currentNode);
            currentNode = nextSibling;
        }
    };
    const replace = (node, parentDomNode) => {
        if (node instanceof Array) {
            for (const item of node) {
                replace(item, parentDomNode);
            }
        }
        else if (node instanceof Function) {
            replace(node(parentDomNode), parentDomNode);
        }
        else if (currentNode[NODE_MOUNT_VALUE_KEY] !== node) {
            removeUnusedNodes();
            const cached = getNodeCachedSet(node);
            if (cached.size === 0) {
                cached.add((0, exports.kix)(null, node));
            }
            for (const mountDomNode of cached) {
                cached.delete(mountDomNode);
                const unmount = () => cached.add(mountDomNode);
                loopEachItems(mountDomNode, (domNode) => {
                    var _a;
                    domNode[NODE_UNMOUNT_FUNCTION_KEY] = unmount;
                    domNode[NODE_MOUNT_VALUE_KEY] = node;
                    parentDomNode.insertBefore(domNode, endMarker);
                    (_a = domNode[NODE_MOUNT_FUNCTION_KEY]) === null || _a === void 0 ? void 0 : _a.call(domNode);
                });
                break;
            }
        }
        else {
            while (currentNode[NODE_MOUNT_VALUE_KEY] === node && currentNode !== endMarker) {
                currentNode = currentNode.nextSibling || startMarker;
            }
        }
    };
    const Render = (node) => {
        const parentNode = startMarker.parentNode;
        if (parentNode) {
            currentNode = startMarker.nextSibling;
            replace(node, parentNode);
            if (currentNode !== startMarker) {
                removeUnusedNodes();
            }
        }
        else {
            endMarker[NODE_MOUNT_FUNCTION_KEY] = () => {
                currentNode = startMarker.nextSibling;
                replace(node, startMarker.parentNode);
                if (currentNode !== startMarker) {
                    removeUnusedNodes();
                }
            };
        }
    };
    return [
        [startMarker, endMarker],
        Render,
    ];
};
exports.kix = createApp((elementName) => DocumentObject.createElement(elementName), (node, attributeName, value) => node.setAttribute(attributeName, value));
exports.default = exports.kix;
class Component {
    render() { }
}
exports.Component = Component;
exports.Router = {
    getPathParams(path) {
        return RoutePathParams[path] || (RoutePathParams[path] = {});
    },
    getGlobalParams() {
        return GlobalRouteParams;
    },
    history: WindowObject.history
};
const createElement = (tagName, renderCallback) => {
    abstractNodes[tagName] = (objectNode, tagName, kix, createElement, setAttribute, createObjectElement) => {
        var _a;
        (_a = objectNode[KIX_UNIQUE_APP_USABLE_KEY]) === null || _a === void 0 ? void 0 : _a.call(objectNode);
        return renderCallback(objectNode, tagName, kix, createElement, setAttribute, createObjectElement);
    };
};
exports.createElement = createElement;
const createAttribute = (attributeName, renderCallback, autoSet) => {
    abstractAttributes[attributeName] = (node, attributeName, value, setAttribute) => {
        const setValue = renderCallback(node, attributeName, value, setAttribute);
        if (autoSet) {
            setAttribute(node, attributeName, setValue);
        }
    };
};
exports.createAttribute = createAttribute;
const useListener = (objectValue, propertyName, callback = () => { }) => {
    const createCallbackChannel = (childCallback = () => { }) => {
        let isOpen = true;
        const listenerService = {
            addCallback: (newCallback) => {
                const parentCallback = childCallback;
                childCallback = () => {
                    parentCallback(currentValue, propertyName, objectValue);
                    newCallback(currentValue, propertyName, objectValue);
                };
                return listenerService;
            },
            addChildListener: (newCallback) => {
                const childChannel = createCallbackChannel(newCallback);
                const parentCallback = childCallback;
                childCallback = () => {
                    parentCallback(currentValue, propertyName, objectValue);
                    if (childChannel.isOpen()) {
                        childChannel.init();
                    }
                };
                return childChannel;
            },
            close: () => {
                isOpen = false;
                return listenerService;
            },
            isOpen: () => {
                return isOpen;
            },
            open: () => {
                isOpen = true;
                return listenerService;
            },
            init: () => {
                childCallback(currentValue, propertyName, objectValue);
                return listenerService;
            },
            getValue: () => currentValue
        };
        return listenerService;
    };
    const channel = createCallbackChannel(callback);
    let currentValue = propertyRegistration((r) => (r(objectValue, propertyName)), (value) => {
        currentValue = value;
        if (channel.isOpen()) {
            channel.init();
        }
    });
    return channel;
};
exports.useListener = useListener;
const useObjectListener = (objectValue, callback = () => { }, listenKeys) => {
    const eachCall = (keys, call) => {
        if (keys) {
            for (const propKey of keys) {
                call(propKey);
            }
        }
        else {
            for (const propKey in objectValue) {
                call(propKey);
            }
        }
    };
    const createCallbackChannel = (childCallback = () => { }) => {
        let isOpen = true;
        const listenerService = {
            addCallback: (newCallback) => {
                const parentCallback = childCallback;
                childCallback = (...args) => {
                    parentCallback(...args);
                    newCallback(...args);
                };
                return listenerService;
            },
            addChildListener: (newCallback) => {
                const childChannel = createCallbackChannel(newCallback);
                const parentCallback = childCallback;
                childCallback = (objectValue, name, value) => {
                    parentCallback(objectValue, name, value);
                    if (childChannel.isOpen()) {
                        childChannel.initEach([name]);
                    }
                };
                return childChannel;
            },
            close: () => {
                isOpen = false;
                return listenerService;
            },
            isOpen: () => {
                return isOpen;
            },
            open: () => {
                isOpen = true;
                return listenerService;
            },
            initEach: (propertyNames = listenKeys) => {
                eachCall(propertyNames, (name) => {
                    if (name in objectValue) {
                        childCallback(objectValue, name, objectValue[name]);
                    }
                });
                return listenerService;
            },
            getValue: () => objectValue
        };
        return listenerService;
    };
    const channel = createCallbackChannel(callback);
    eachCall(listenKeys, (propertyName) => propertyRegistration((r) => (r(objectValue, propertyName)), () => {
        if (channel.isOpen()) {
            channel.initEach([propertyName]);
        }
    }));
    return channel;
};
exports.useObjectListener = useObjectListener;
